#[doc = "Register `TTCAN_COMPARE` reader"]
pub struct R(crate::R<TTCAN_COMPARE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<TTCAN_COMPARE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<TTCAN_COMPARE_SPEC>> for R {
    fn from(reader: crate::R<TTCAN_COMPARE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `TTCAN_COMPARE` writer"]
pub struct W(crate::W<TTCAN_COMPARE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<TTCAN_COMPARE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<TTCAN_COMPARE_SPEC>> for W {
    fn from(writer: crate::W<TTCAN_COMPARE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `TIME_MARK` reader - compare target,?when TTCAN_COUNTER.LOCAL_TIME counts to TT_COMPARE, INTR_CAN.TT_COMPARE will be set"]
pub struct TIME_MARK_R(crate::FieldReader<u16, u16>);
impl TIME_MARK_R {
    pub(crate) fn new(bits: u16) -> Self {
        TIME_MARK_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TIME_MARK_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TIME_MARK` writer - compare target,?when TTCAN_COUNTER.LOCAL_TIME counts to TT_COMPARE, INTR_CAN.TT_COMPARE will be set"]
pub struct TIME_MARK_W<'a> {
    w: &'a mut W,
}
impl<'a> TIME_MARK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xffff << 16)) | ((value as u32 & 0xffff) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bits 16:31 - compare target,?when TTCAN_COUNTER.LOCAL_TIME counts to TT_COMPARE, INTR_CAN.TT_COMPARE will be set"]
    #[inline(always)]
    pub fn time_mark(&self) -> TIME_MARK_R {
        TIME_MARK_R::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 16:31 - compare target,?when TTCAN_COUNTER.LOCAL_TIME counts to TT_COMPARE, INTR_CAN.TT_COMPARE will be set"]
    #[inline(always)]
    pub fn time_mark(&mut self) -> TIME_MARK_W {
        TIME_MARK_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "TTCAN Level1 compare configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [ttcan_compare](index.html) module"]
pub struct TTCAN_COMPARE_SPEC;
impl crate::RegisterSpec for TTCAN_COMPARE_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [ttcan_compare::R](R) reader structure"]
impl crate::Readable for TTCAN_COMPARE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [ttcan_compare::W](W) writer structure"]
impl crate::Writable for TTCAN_COMPARE_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets TTCAN_COMPARE to value 0"]
impl crate::Resettable for TTCAN_COMPARE_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
